/* Generated from Extensions for 'extended' examples
 */
 
#include <QFlags>

/**
 * \addtogroup typesconstants Types and constants
 *
 * Enumerated, flag, structure, list and mapping types and utility constants.
 */

/**
 * \defgroup flagtypeconsts Flag type constants
 * \ingroup typesconstants
 *
 * Types generated from the specification representing bit flag constants and
 * combinations of them (bitfields).
 */

/**
 * \defgroup enumtypeconsts Enumerated type constants
 * \ingroup typesconstants
 *
 * Types generated from the specification representing enumerated types ie.
 * types the values of which are mutually exclusive integral constants.
 */

/**
 * \defgroup ifacestrconsts Interface string constants
 * \ingroup typesconstants
 *
 * D-Bus interface names of the interfaces in the specification.
 */

/**
 * \defgroup errorstrconsts Error string constants
 * \ingroup typesconstants
 *
 * Names of the D-Bus errors in the specification.
 */

namespace Example
{
/**
 * \enum HatStyle
 * \ingroup enumtypeconsts
 *
 * Enumerated type generated from the specification.
 */
enum HatStyle
{
    /**
     * There is no hat. color MUST be the empty string and properties MUST be 
     * an empty mapping.
     */
    HatStyleNone = 0,

    /**
     * An unspecified type of hat.
     */
    HatStyleOther = 1,

    /**
     * A fedora, which MAY be red.
     */
    HatStyleFedora = 2,

    /**
     * A knitted hat, with or without a bobble.
     */
    HatStyleKnitted = 3,

    /**
     * A bowler hat, as worn by stereotypical English businessmen.
     */
    HatStyleBowler = 4,

    _HatStylePadding = 0xffffffffU
};

/**
 * \ingroup enumtypeconsts
 *
 * 1 higher than the highest valid value of HatStyle.
 */
const int NUM_HAT_STYLES = (4+1);

}

/**
 * \ingroup ifacestrconsts
 *
 * The interface name "com.example.Telepathy.Connection.Interface.Hats".
 */
#define EXAMPLE_INTERFACE_CONNECTION_INTERFACE_HATS "com.example.Telepathy.Connection.Interface.Hats"

